#include "stdafx.h"
#include "OpenGLRendererTrack.h"


COpenGLRendererTrack::COpenGLRendererTrack() :
	m_eTrackingMode( TM_NONE ),
	m_fRenderingRate( 10 )
{
	m_f3RenderingCenter[0] = 0.0;
	m_f3RenderingCenter[1] = 0.0;
	m_f3RenderingCenter[2] = 0.0;
	m_f16ViewingTransformMatrix[0] = 1.0f; m_f16ViewingTransformMatrix[1] = 0.0f; m_f16ViewingTransformMatrix[2] = 0.0f; m_f16ViewingTransformMatrix[3] = 0.0f;
	m_f16ViewingTransformMatrix[4] = 0.0f; m_f16ViewingTransformMatrix[5] = 1.0f; m_f16ViewingTransformMatrix[6] = 0.0f; m_f16ViewingTransformMatrix[7] = 0.0f;
	m_f16ViewingTransformMatrix[8] = 0.0f; m_f16ViewingTransformMatrix[9] = 0.0f; m_f16ViewingTransformMatrix[10] = 1.0f; m_f16ViewingTransformMatrix[11] = 0.0f;
	m_f16ViewingTransformMatrix[12] = 0.0f; m_f16ViewingTransformMatrix[13] = 0.0f; m_f16ViewingTransformMatrix[14] = 0.0f; m_f16ViewingTransformMatrix[15] = 1.0f;
}


COpenGLRendererTrack::~COpenGLRendererTrack()
{
}

void COpenGLRendererTrack::BeginTracking( HWND hWnd, POINT point, ETRACKINGMODE eTrackingMode )
{
	SetCapture( hWnd );
	m_eTrackingMode = eTrackingMode;
	m_ptLast = point;
}

void COpenGLRendererTrack::EndTracking()
{
	ReleaseCapture();
	m_eTrackingMode = TM_NONE;
}

bool COpenGLRendererTrack::DoTracking( POINT point )
{
	LONG lDeltaX = point.x - m_ptLast.x;
	LONG lDeltaY = point.y - m_ptLast.y;
	m_ptLast = point;
	switch( m_eTrackingMode )
	{
		case TM_NONE:
			return false;
		case TM_ROTATION:
			{
				// NCAg̈̏c̒Z̒̃sNZƔi180xj悤
				float fAngle_deg = (float)( sqrt( lDeltaX * lDeltaX + lDeltaY * lDeltaY ) * 180.0 / ( m_cx < m_cy ? m_cx : m_cy ) );
				// ]}gbNX݂̃IuWFNgtH[}gbNXɊ|킹
				glPushMatrix();
				glLoadIdentity();
				glRotatef( fAngle_deg, (GLfloat)lDeltaY, (GLfloat)lDeltaX, 0 );
				glMultMatrixf( (GLfloat*)m_f16ViewingTransformMatrix );
				glGetFloatv( GL_MODELVIEW_MATRIX, (GLfloat*)m_f16ViewingTransformMatrix );
				glPopMatrix();
				// fOr[COϊs̐ݒ
				SetupModelViewMatrix();
			}
			return true;
		case TM_PAN:
			{
				m_f3RenderingCenter[0] -= lDeltaX / m_fRenderingRate;
				m_f3RenderingCenter[1] += lDeltaY / m_fRenderingRate;
				// fOr[COϊs̐ݒ
				SetupModelViewMatrix();
			}
			return true;
		case TM_ZOOM:
			{	// gEkɂ`{
				// +500Ŕ{2{ɁA+250Ŕ{1.5{ɁA
				// -500Ŕ{0.5{ɁA-1000Ŕ{0.25{
				m_fRenderingRate *= (float)pow( 2, -lDeltaY * 0.002f );
				// eϊs̐ݒ
				SetupProjectionMatrix();
			}
			return true;
		default:
			assert( !"Ή" );
			break;
	}
	return false;
}

bool COpenGLRendererTrack::SetupProjectionMatrix()
{
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();

	glOrtho( -m_cx * 0.5 / m_fRenderingRate,	// left
		m_cx * 0.5 / m_fRenderingRate,	// right
		-m_cy * 0.5 / m_fRenderingRate,	// buttom
		m_cy * 0.5 / m_fRenderingRate,	// top
		0.1,			// near
		1000.0 );			// far

	// eϊsɑ΂鏈͂ŊB
	// ȍ~̕ϊs񏈗́Afr[ϊsɑ΂Ď{悤ɂB
	glMatrixMode( GL_MODELVIEW );
	return true;
}

bool COpenGLRendererTrack::SetupModelViewMatrix()
{
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	gluLookAt( m_f3RenderingCenter[0], m_f3RenderingCenter[1], m_f3RenderingCenter[2] + 500.0,	// _
		m_f3RenderingCenter[0], m_f3RenderingCenter[1], m_f3RenderingCenter[2],			// _
		0.0, 1.0, 0.0 );	// xNg

	glMultMatrixf( (GLfloat*)m_f16ViewingTransformMatrix );	// \]if]j

	return true;
}
